/**************************************************************************//**
 * @item     CosyOS-II Config
 * @file     syscfg.h
 * @brief    OS Config File
 * @author   ٿ
 * @version  V2.0.0
 * @date     2024.03.17
 ******************************************************************************/

#ifndef __SYSCFG_H
#define __SYSCFG_H
#include "..\System\os_def.h"

///////////////////////////////////////////////////////////////////////////////

          //*** <<< Use Configuration Wizard in Context Menu >>> ***//

///////////////////////////////////////////////////////////////////////////////
// <h> ϵͳ
// <i> ϵͳ

// <o> MCUں
// <0=> 8051 <1=> 80251 <2=> Cortex-M
// <i> ֪CosyOSMCUںˣCosyOSԶƥMCUļ
#define __SYSCFG_MCUCORE                 1
#if   __SYSCFG_MCUCORE == 0
#define SYSCFG_MCUCORE                   8051
#elif __SYSCFG_MCUCORE == 1
#define SYSCFG_MCUCORE                   80251
#elif __SYSCFG_MCUCORE == 2
#define SYSCFG_MCUCORE                   cmx
#endif

// <s> ׼ͷļ
// <i> MCUƥı׼ͷļcļвٰļ
// <i> ʾһSTC8.H
// <i> ʾ..\MCU\STC8.Hְ·дͼûʱ⣬ı༭жǿУԡ
// <i> ı༭жʱӦ˫ţ磺"..\MCU\STC8.H"
#define SYSCFG_STANDARDHEAD              "STC32G.H"

// <o> ϵͳʱƵʣHZ
// <i> ֪CosyOSõϵͳʱӣλΪȡ
#define SYSCFG_SYSCLK                    24000000
#if SYSCFG_SYSCLK < 1000000UL
#error Ƿֵ
#endif

// <o> ϵͳδڣus
// <i> ϵͳδʱʱ䣬λΪ΢롣
// <i> CosyOSʱʱʱʱȲĻʱͲ
// <i> ɿϵͳδʱͳƹܣ趨ֵӦԶͳֵ
#define SYSCFG_SYSTICKCYCLE              1000
#if SYSCFG_SYSTICKCYCLE < 1 || SYSCFG_SYSTICKCYCLE > 1000000UL
#error Ƿֵ
#endif

// <q> ȫʱ
// <i> Ƿðȫʱ
// <i> ȫʱCosyOSİȫؼ֮һɷֹĳڶռʱʹô
#define SYSCFG_SAFERUNTIME               0

// </h>
///////////////////////////////////////////////////////////////////////////////
// <e> DEBUGӿ
// <i> ǷDEBUGӿڣ
// <i> DEBUGӿкͨѶרýӿڣӦΪרһڡ
#define SYSCFG_DEBUGGING                 1

#if SYSCFG_DEBUGGING == 0
#define SYSCFG_TASKPC_MONITOR            0
#define SYSCFG_PENDSVFIFO_MONITOR        0
#define SYSCFG_SYSTICKTIME_COUNT         0
#else

// <q> PC
// <i> ǷPCأ
// <i> ʱлջPCֵ
// <i> ִпѭʱ˹ܿûλãԱBUGע⣬PCֵΪһָĵַ
// <i> ڵԽ׶οܣʽĲƷɽܡ
// <i> ĳִпѭı֣
// <i> ʼΪ״̬ռýϸߵCPUʹʣȼ͵һֱûлС
#define SYSCFG_TASKPC_MONITOR            1

// <q> PendSV_FIFO
// <i> ǷPendSV_FIFOأ
// <i> ϵͳԶPendSV_FIFOʵռȣͨʽΪʷֵ/ֵ
// <i> ڵԽ׶οܣʽĲƷɽܡ
#define SYSCFG_PENDSVFIFO_MONITOR        1

// <q> ϵͳδʱͳ
// <i> Ƿϵͳδʱͳƣ
// <i> ͳSysTick_Handler/ʱ0жϣÿϵͳδʱƽֵ
// <i> ڵԽ׶οܣʽĲƷɽܡ
#define SYSCFG_SYSTICKTIME_COUNT         1

#endif

// <q> Զ
// <i> 豸ǷԶ
#define SYSCFG_TASKMGRAUTOSTART          1

// <o> Ĭϸٶ
// <500=> ٣500룩<1000=> ٣1룩<2000=> ٣2룩
// <i> Ĭϸٶ
#define SYSCFG_TASKMGRUPSPEED            1000

// <o> ڷʹ
// <i> DEBUGӿڵĴڷʹܣӦı༭ж塣
// <i> ʾ
// <i> 8051/251-UART1TI = 1
// <i> STM32 - USART1USART_ITConfig(USART1, USART_IT_TXE, ENABLE)
#define SYSCFG_DEBUGSEND                 TI = 1

// </e>
///////////////////////////////////////////////////////////////////////////////
// <h> 
// <i> 

// <o> ȼ
// <8=> 8 <16=> 16 <32=> 32 <64=> 64 <128=> 128 <256=> 256
// <i> ɹѡ8163264128256Ҳı༭Զ
// <i> CosyOSȼֵԽȼԽߣֵԽСȼԽͣȼ̶Ϊ0
// <i> õķΪ8ȼΪ7ȼΪ0
#define SYSCFG_TASKPRIORITY              8

// <h> ʱƬģʽ
// <i> CosyOSʱƬĶģʽȫʱƬ㷨ʱƬԶʱƬֻѡһ
// <i> ȫʱƬͬʱƬ
// <i> 㷨ʱƬͬȼʱƬͬһ㷨ʽ
// <i> ԶʱƬͬȼʱƬͬûԶȼʱƬ
// <i> ȫʱƬ򵥸ЧʱƬתΪѣ㷨ʱƬԶʱƬʵֲͬȼġϸʱƬơ
// <i> ʱƬȡֵΧ<1-65535>λΪδڡ

// <e> ȫʱƬ
// <i> ǷȫʱƬ
#define __SYSCFG_GLOBALTIMESHARING       1
// <o> ȫʱƬ
// <i> ȫʱƬ
#define SYSCFG_GLOBALTIMESHARING         100
// </e>

// <e> 㷨ʱƬ
// <i> Ƿ㷨ʱƬ
#define __SYSCFG_ALGORITHMTIMESHARING    0
// <o> ʱƬ㷨
// <i> ʱƬ = f(tpl)tplΪȼ
// <i> Ӧı༭ж塣
// <i> ʾ(256 - tpl)
#define SYSCFG_ALGORITHMTIMESHARING(tpl) (tpl)
// </e>

// <e> ԶʱƬ
// <i> ǷԶʱƬ
#define __SYSCFG_CUSTOMTIMESHARING       0
// <o> ʱƬ
// <i> ȼ0ʼдȼʱƬöż
// <i> Ӧı༭ж塣
// <i> ʾȼΪ8ʱ80,70,60,50,40,30,20,10
#define SYSCFG_CUSTOMTIMESHARING         80,70,60,50,40,30,20,10
// <o> ʱƬֵ
// <i> ʱƬֵ
#define SYSCFG_TIMESHARING_MAX           255
// </e>

#if   __SYSCFG_GLOBALTIMESHARING == 1 && __SYSCFG_ALGORITHMTIMESHARING == 0 && __SYSCFG_CUSTOMTIMESHARING == 0
#define SYSCFG_TIMESHARINGMODE           0
#elif __SYSCFG_GLOBALTIMESHARING == 0 && __SYSCFG_ALGORITHMTIMESHARING == 1 && __SYSCFG_CUSTOMTIMESHARING == 0
#define SYSCFG_TIMESHARINGMODE           1
#elif __SYSCFG_GLOBALTIMESHARING == 0 && __SYSCFG_ALGORITHMTIMESHARING == 0 && __SYSCFG_CUSTOMTIMESHARING == 1
#define SYSCFG_TIMESHARINGMODE           2
#elif __SYSCFG_GLOBALTIMESHARING == 0 && __SYSCFG_ALGORITHMTIMESHARING == 0 && __SYSCFG_CUSTOMTIMESHARING == 0
#error ʱƬģʽδ壡
#else
#error ʱƬģʽض壡
#endif

// </h>

// <o> û
// <i> ָû񣬲ϵͳޡ
// <i> ӦڵʵʵСڡֻռһЩڴ棬С˻ᵼĳЩ޷л쳣
#define SYSCFG_USERTASKTOTAL             8

// <o> ûʱж
// <i> ȡֵΧ<0-64>
// <i> ûĶʱж/
// <i> ӦʵʵȲܴҲСڡ赣ĻΪֻҪʵʲͻᱨ
#define SYSCFG_USERTIMINTTOTAL           0
#if SYSCFG_USERTIMINTTOTAL > 64
#error Ƿֵ
#endif

// <o> ûʱѯ
// <i> ȡֵΧ<0-64>
// <i> ûĶʱѯ/
// <i> ӦʵʵȲܴҲСڡ赣ĻΪֻҪʵʲͻᱨ
#define SYSCFG_USERTIMQRYTOTAL           0
#if SYSCFG_USERTIMQRYTOTAL > 64
#error Ƿֵ
#endif

// <o> 󳤶
// <i> ȡֵΧ<8-255>
// <i> Ӧ̣ɹΪܵflashڴռһӰ졣
#define SYSCFG_TASKNAMELEN_MAX           16
#if SYSCFG_TASKNAMELEN_MAX < 8 || SYSCFG_TASKNAMELEN_MAX > 255
#error Ƿֵ
#endif

// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> Ӻ
// <i> Ӻ

// <q> δ
// <i> Ƿõδӣ
#define SYSCFG_TICKHOOK                  0

// <q> й
// <i> Ƿÿйӣ
#define SYSCFG_IDLEHOOK                  0

// <q> жϷ
// <i> ǷжϷӣ
#define SYSCFG_PENDSVHOOK                0

// <q> ȫֱ
// <i> Ƿȫֱӣ
#define SYSCFG_GVARHOOK                  0

// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> ʱ
// <i> ʱ

// <o> ʱʱλ/ʱʱЧֵϵͳδ
// <8=> 8λ/254 <16=> 16λ/65,534 <32=> 32λ/4,294,967,294 <64=> 64λ
// <i> MCUںΪ8051龡Ϊλ8λ/16λ⽫ʹ󲿷ִЧԼ10%
#define SYSCFG_DELAYBITS                 32

// <o> ʱж϶ʱλ/ʱЧֵϵͳδ
// <8=> 8λ/254 <16=> 16λ/65,534 <32=> 32λ/4,294,967,294 <64=> 64λ
// <i> MCUںΪ8051龡Ϊλܡ
#define SYSCFG_TIMINTBITS                32

// <o> ʱѯʱλ/ʱЧֵϵͳδ
// <8=> 8λ/254 <16=> 16λ/65,534 <32=> 32λ/4,294,967,294 <64=> 64λ
// <i> MCUںΪ8051龡Ϊλܡ
#define SYSCFG_TIMQRYBITS                32

// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> ߳ͨ
// <i> ߳ͨ

// <q> ź
// <i> Ƿûź
#define SYSCFG_MUTEX                     0

// <q> ֵź
// <i> Ƿöֵź
#define SYSCFG_BINARY                    0

// <e> ź
// <i> Ƿüź
#define SYSCFG_SEMAPHORE                 0
// <o> źλ/ֵ
// <8=> 8λ/255 <16=> 16λ/65,535 <32=> 32λ/4,294,967,295 <64=> 64λ
// <i> MCUںΪ8051龡Ϊλܡ
#define SYSCFG_SEMAPHOREBITS             32
// </e>

// <q> ¼־
// <i> Ƿ¼־飿
#define SYSCFG_FLAGGROUP                 0

// <e> ˽
// <i> Ƿ˽ţ
#define SYSCFG_TASKMSG                   0
// <o> ˽Ŵģʽ
// <0=> ܴģʽ <1=> ܴģʽ
// <i> ˽ŴģʽܴģʽܴģʽCortex-Mںˣ֧ܴģʽ
// <i> ܴģʽڴռý϶࣬˽Чʵͣ805180251ںˣֱʹ񼴿ɡCortex-MںˣʹԤָϣAPI˵ʾ
// <i> ܴģʽڴռý٣˽ЧʸߣʹԤָϣAPI˵ʾ
#define SYSCFG_TASKMSGMODE               1
// </e>

// <q> 
// <i> Ƿ÷ţ
#define SYSCFG_FETION                    0

// <e> Ϣ
// <i> ǷϢ䣿
#define SYSCFG_MAILBOX                   0
// <o> ʻ
// <0=>  <1=> 
// <i> ʣжнʼʱڱд룬ʧܣfalse
// <i> ʣжнʼʱڱд룬Կɳɹʼȡдȡľֲ䣩
// <i> ʣɽԼڴ桢ٴ߷Чʡ
#define SYSCFG_MAILBOX_ACCESSMECHANISM   1
// </e>

// <q> Ϣ
// <i> ǷϢУ
#define SYSCFG_MSGQUEUE                  0

// </h>
///////////////////////////////////////////////////////////////////////////////
// <h> 
// <i> 

// <q> û̬ڴ
// <i> Ƿʹö̬ڴ䣿ڴ߳ڴ䡣
#define SYSCFG_DYNMEMMGE                 0

// <e> RTC
// <i> ǷRTC
#define SYSCFG_SOFTRTC                   0

// <h> 

// <o> 
// <2023=> 2023 <2024=> 2024 <2025=> 2025 <2026=> 2026 <2027=> 2027 <2028=> 2028 <2029=> 2029
// <2030=> 2030 <2031=> 2031 <2032=> 2032 <2033=> 2033 <2034=> 2034 <2035=> 2035 <2036=> 2036 <2037=> 2037 <2038=> 2038 <2039=> 2039
// <2040=> 2040 <2041=> 2041 <2042=> 2042 <2043=> 2043 <2044=> 2044 <2045=> 2045 <2046=> 2046 <2047=> 2047 <2048=> 2048 <2049=> 2049
// <2050=> 2050 <2051=> 2051 <2052=> 2052 <2053=> 2053 <2054=> 2054 <2055=> 2055 <2056=> 2056 <2057=> 2057 <2058=> 2058 <2059=> 2059
// <2060=> 2060 <2061=> 2061 <2062=> 2062 <2063=> 2063 <2064=> 2064 <2065=> 2065 <2066=> 2066 <2067=> 2067 <2068=> 2068 <2069=> 2069
// <2070=> 2070 <2071=> 2071 <2072=> 2072 <2073=> 2073 <2074=> 2074 <2075=> 2075 <2076=> 2076 <2077=> 2077 <2078=> 2078 <2079=> 2079
// <2080=> 2080 <2081=> 2081 <2082=> 2082 <2083=> 2083 <2084=> 2084 <2085=> 2085 <2086=> 2086 <2087=> 2087 <2088=> 2088 <2089=> 2089
// <2090=> 2090 <2091=> 2091 <2092=> 2092 <2093=> 2093 <2094=> 2094 <2095=> 2095 <2096=> 2096 <2097=> 2097 <2098=> 2098 <2099=> 2099
#define __SYSCFG_YEAR                    2023

// <o> 
// <1=> 1 <2=> 2 <3=> 3 <4=> 4 <5=> 5 <6=> 6 <7=> 7 <8=> 8 <9=> 9 <10=> 10 <11=> 11 <12=> 12
#define __SYSCFG_MONTH                   3

// <o> 
// <1=> 1 <2=> 2 <3=> 3 <4=> 4 <5=> 5 <6=> 6 <7=> 7 <8=> 8 <9=> 9 <10=> 10
// <11=> 11 <12=> 12 <13=> 13 <14=> 14 <15=> 15 <16=> 16 <17=> 17 <18=> 18 <19=> 19 <20=> 20
// <21=> 21 <22=> 22 <23=> 23 <24=> 24 <25=> 25 <26=> 26 <27=> 27 <28=> 28 <29=> 29 <30=> 30 <31=> 31
#define __SYSCFG_DATE                    7

// <o> 
// <1=> һ <2=>  <3=>  <4=>  <5=>  <6=>  <7=> 
#define __SYSCFG_WEEK                    2

#define SYSCFG_MANUFACTUREDATE           __SYSCFG_YEAR, __SYSCFG_MONTH, __SYSCFG_DATE, 0, 0, 0, __SYSCFG_WEEK

// </h>
// </e>
// </h>
///////////////////////////////////////////////////////////////////////////////

                //*** <<< end of configuration section >>> ***//

///////////////////////////////////////////////////////////////////////////////

#endif
