/**************************************************************************//**
 * @item     CosyOS-II Hook
 * @file     start_hook.c
 * @brief    启动钩子
 * @detail   在启动任务中被调用，可在此启动用户任务。
 * @service  uStartTask(task, status); 启动任务
             uStartTask_Ready(task);   启动任务并就绪
             uStartTask_Suspend(task); 启动任务并挂起
 * @author   迟凯峰
 * @version  V2.0.0
 * @date     2024.03.17
 ******************************************************************************/

#include "..\System\os_link.h"
#include "CosyOS.h"
#include "display.h"
#include "rtc.h"
#include "ntc.h"
#include "adckey.h"
#include "uart2_3.h"
#include "MatrixKey.h"
#include "i2c_ps.h"
#include "pwmb.h"
void start_hook(void)
{
	uStartTask_Ready(vDisplayTask);
	uStartTask_Ready(vRtcTask);
	uStartTask_Ready(vAdcKeyTask);
	uStartTask_Ready(vNtcTask);
	uStartTask_Ready(vUart2_3Task);
	uStartTask_Ready(vMatrixKeyTask);
	uStartTask_Ready(vI2C_PsTask);
	uStartTask_Ready(vPWMB_LedTask);
}
